unit clMyActions;

{$mode objfpc}{$H+}

interface

uses classes, ActnList, dialogs, sysutils;

type
  TButtonAction = (macNew,macEdit,macPost,macDelete,macRew,macForward,macSearch,macCancel,macClose);
  TButtonActions = set of TButtonAction;

  TMyActions = class
    strict private
      fActionlist   : TActionlist;
      fButtonAction : TButtonActions;
    public
    procedure ActionListDisable;
    procedure ActionListEnable;
    procedure SetInvisible(const aButtons : TButtonActions = []);

    procedure DisableEditKey;
    procedure OnlyClose;
    procedure PostAndClose(const aExecute : boolean = false);

    property Actionlist : TActionlist read fActionlist write fActionlist;
    property ButtonSet  : TButtonActions read fButtonAction write fButtonAction;
end;


implementation

{ TMyActions }

procedure TMyActions.ActionListDisable;
begin
  if fActionlist <> nil then
    fActionlist.State := asSuspended;
end;

procedure TMyActions.ActionListEnable;
begin
  if fActionlist <> nil then
    fActionlist.State := asnormal;
end;

procedure TMyActions.DisableEditKey;
begin
  fButtonAction := [macEdit];
end;

procedure TMyActions.OnlyClose;
begin
  fButtonAction := [macNew,macEdit,macPost,macDelete,macRew,macForward,macSearch,macCancel];
  SetInvisible
end;

procedure TMyActions.PostAndClose(const aExecute : boolean);
begin
  fButtonAction := [macNew,macEdit,macDelete,macRew,macForward,macSearch,macCancel];
  if aExecute then
    SetInvisible
end;

procedure TMyActions.SetInvisible(const aButtons : TButtonActions);
var emptySet : TButtonActions;
    n        : TButtonAction;
begin
  emptySet := [];
  if aButtons <> EmptySet then
    fButtonAction := aButtons;
  for n := low(TButtonAction) to high(TButtonAction) do
  begin
    if n in fButtonAction then
    begin
      TCustomAction(fActionlist.Actions[Ord(n)]).Visible := false;
      TCustomAction(fActionlist.Actions[Ord(n)]).Enabled := false;
    end;
   end;
end;

end.
