unit cllazmatrixstrings;

interface

uses
  SysUtils, Variants, Classes, Bufdataset, DB, dialogs;

type
  TArray_of_dataset = array of Tdataset;

  { TMatrixString }

  TMatrixString = class
  private
    FProgrammaID  : string;
    VirtualTable  : array[0..6] of TBufdataset;
    FDataSource   : array[0..6] of TDataSource;
    FMatrixTeller : integer;
    procedure SetProgrammaID(const StrWaarde : string);
    function GetProgrammaID : string;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    procedure CopyCBSDataset(CopyDsSet: TDataSet; const ParIntNummer: word);
    procedure CopyDataset(CopyDsSet: TDataSet; const ParIntNummer: word);
    procedure NewRecord(const ParIntNummer : word = 1);
    procedure SetMaster(const DsMasterNr, DsDetailNr : word);
    procedure SetMasterFields(const ParStrFields : string; const ParIntNummer : word = 1);
    procedure SetIndexFields(const ParStrFields: string;
      const ParIntNummer : word = 1);

    function CreateMatrixFields(DBStructuur : array of string; const MatrixNr : byte = 1;
             const ExtraField : boolean = true) : boolean;
    function Active(const ParIntNummer : word = 1) : boolean;
    function Dataset(const ParIntNummer : word = 1) : TBufdataset;
    function PostRecord(const ParIntNummer : word = 1) : boolean;
    function CancelRecord(const ParIntNummer: word = 1): boolean;
    function SaveField(const VeldWaarde : Variant;
                       const BronVeld : string;
                       const ParIntNummer : word = 1) : boolean;
    function GetDataSource(const ParIntNummer : word = 1) : TDataSource;
    function DataSourceLength(const ParIntNummer: word = 1): integer;
    function FieldValue(const Veldnaam: string;
      const ParIntNummer: word = 1): variant;
    function CreateMatrixStringFields(VirtTable: TBufdataset;
      const MatrixNr: byte = 1): boolean;
    function Locate(const zoekstring: string;
      arValues: array of variant; const MatrixNr: byte = 1): boolean;
    function Load(Bestand : string; const Matrixnr : byte = 1) : boolean;
    function Save(Bestand: string;  const Matrixnr : byte = 1): boolean;

    property Progrid : string read GetProgrammaID write SetProgrammaID;
  end;

implementation

constructor TMatrixString.Create;
var teller : byte;
begin
  for Teller := 0 to high(VirtualTable) do
  begin
    VirtualTable[Teller] := TBufdataset.Create(nil);
    FDataSource[Teller]  := TDataSource.Create(nil);
  end;
end;

destructor TMatrixString.Destroy;
var teller : byte;
begin
  for Teller := 0 to high(VirtualTable) do
  begin
    FDataSource[Teller].free;
    VirtualTable[Teller].Active := false;
    VirtualTable[Teller].Free;
  end;
end;

function TMatrixString.FieldValue(const Veldnaam : string;
                            const ParIntNummer : word = 1) : variant;
begin
  FMatrixTeller := ParIntNummer - 1;
  result := VirtualTable[FMatrixTeller].FieldByName(Veldnaam).Value;
end;


function TMatrixString.SaveField(const VeldWaarde : Variant;
                           const BronVeld : string;
                           const ParIntNummer : word = 1) : boolean;
var Field : TField;
S : string;
begin
  try
    FMatrixTeller := ParIntNummer - 1;
    // zoeken naar het juiste veldtype
    Field := VirtualTable[FMatrixTeller].FindField(BronVeld);
    if not (Field = nil) then
    begin
      S := Field.DisplayName;
      case Field.DataType of
        ftString : VirtualTable[FMatrixTeller].FieldByName(Bronveld).AsString := VeldWaarde;
        ftInteger: VirtualTable[FMatrixTeller].FieldByName(Bronveld).AsInteger := VeldWaarde;
        ftFloat  : VirtualTable[FMatrixTeller].FieldByName(Bronveld).AsFloat := VeldWaarde;
        ftDateTime: VirtualTable[FMatrixTeller].FieldByName(Bronveld).AsDateTime := VeldWaarde;
        ftBoolean: VirtualTable[FMatrixTeller].FieldByName(Bronveld).AsBoolean := VeldWaarde;
        ftMemo:    VirtualTable[FMatrixTeller].FieldByName(Bronveld).AsString := VeldWaarde;
      end;
      result := true;
    end else result := false;
  except
    showmessage(Bronveld);
   result := false
  end;
end;

procedure TMatrixString.NewRecord(const ParIntNummer : word = 1);
begin
  FMatrixteller := ParIntNummer - 1;
  VirtualTable[FMatrixTeller].Append;
end;

function TMatrixString.PostRecord(const ParIntNummer : word = 1) : boolean;
begin
  try
    FMatrixteller := ParIntNummer - 1;
    VirtualTable[FMatrixTeller].Post;
    result := true;
  except
    result := false;
  end;
end;

function TMatrixString.CancelRecord(const ParIntNummer : word = 1) : boolean;
begin
  try
    FMatrixteller := ParIntNummer - 1;
    VirtualTable[FMatrixTeller].Cancel;
    result := true;
  except
    result := false;
  end;
end;


function TMatrixString.GetDataSource(const ParIntNummer : word = 1) : TDataSource;
begin
  FMatrixteller := ParIntNummer - 1;
  result := FDataSource[FMatrixteller];
end;

function TMatrixString.DataSourceLength(const ParIntNummer : word = 1) : integer;
begin
  FMatrixteller := ParIntNummer - 1;
  result := VirtualTable[FMatrixTeller].RecordCount;
end;

function TMatrixString.GetProgrammaID: string;
begin
  result := FProgrammaID;
end;

procedure TMatrixString.SetMaster(const DsMasterNr, DsDetailNr : word);
begin
//  FMatrixteller := ParIntNummer - 1;
//  VirtualTable[DsMasterNr - 1].MasterSource := FDatasource[ParIntNummer];
//  FMatrixteller := ParIntNummer - 1;
//  VirtualTable[DsDetailNr - 1].MasterSource := FDatasource[DsMasternr - 1];
end;

procedure TMatrixString.SetMasterFields(const ParStrFields: string; const ParIntNummer : word = 1);
begin
  FMatrixteller := ParIntNummer - 1;
//  VirtualTable[FMatrixTeller].IndexFieldNames := ParStrFields;
//  VirtualTable[FMatrixTeller].MasterFields := ParStrFields;
end;

procedure TMatrixString.SetIndexFields(const ParStrFields: string; const ParIntNummer : word = 1);
begin
  FMatrixteller := ParIntNummer - 1;
  VirtualTable[FMatrixTeller].IndexFieldNames := ParStrFields;
end;

procedure TMatrixString.SetProgrammaID(const StrWaarde: string);
begin
  FProgrammaID := StrWaarde;
end;

function TMatrixString.Dataset(const ParIntNummer : word = 1) : TBufdataset;
begin
  FMatrixteller := ParIntNummer - 1;
  result := VirtualTable[FMatrixTeller];
end;

function TMatrixString.CreateMatrixFields(DBStructuur : array of string; const MatrixNr : byte = 1; const ExtraField : boolean = true) : boolean;
var RecordTeller : word;
    velden       : Tstringlist;
begin
  FMatrixteller := MatrixNr - 1;
  velden := TStringlist.Create;
  try
    Velden.Delimiter := '|';
    Velden.StrictDelimiter := true;
    if VirtualTable[FMatrixTeller].Active then
       VirtualTable[FMatrixTeller].Active := false;
    try
      if ExtraField then
      begin
        with VirtualTable[FMatrixTeller] do
        begin
          with TIntegerField.Create(nil) do
          begin
            Name := 'MSDT_snr';
            FieldKind := fkData;
            FieldName := 'MSDT_snr';
            DataSet := VirtualTable[FMatrixTeller];
          end;
        end;
      end;

      for recordteller := Low(DBStructuur) to High(DBStructuur) do
      begin
        velden.DelimitedText := DBStructuur[recordteller];
        with VirtualTable[FMatrixTeller] do
        begin
          if Velden[2] = 'S' then
          begin
            with TStringField.Create(nil) do
            begin
              Name := Velden[0];
              FieldKind := fkData;
              FieldName := Velden[0];
              Size := strtoint(Velden[1]);
              DataSet := VirtualTable[FMatrixTeller];
            end; //FieldName
          end else if Velden[2] = 'N' then
          begin
            with TIntegerField.Create(nil) do
            begin
              Name := Velden[0];
              FieldKind := fkData;
              FieldName := Velden[0];
              DataSet := VirtualTable[FMatrixTeller];
            end; //FieldName
          end else if (Velden[2] = 'D') or
                      (Velden[2] = 'T') then
          begin
            with TDateTimeField.Create(nil) do
            begin
              Name := Velden[0];
              FieldKind := fkData;
              FieldName := Velden[0];
              DataSet := VirtualTable[FMatrixTeller];
            end; //FieldName
          end else if Velden[2] = 'F' then
          begin
            with TFloatField.Create(nil) do
            begin
              Name := Velden[0];
              FieldKind := fkData;
              FieldName := Velden[0];
              DataSet := VirtualTable[FMatrixTeller];
            end; //FieldName
          end else if Velden[2] = 'M' then
          begin
            with TMemoField.Create(nil) do
            begin
              Name := Velden[0];
              FieldKind := fkData;
              FieldName := Velden[0];
              DataSet := VirtualTable[FMatrixTeller];
            end; //FieldName
          end else if Velden[2] = 'B' then
          begin
            with TBooleanField.Create(nil) do
            begin
              Name := Velden[0];
              FieldKind := fkData;
              FieldName := Velden[0];
              DataSet := VirtualTable[FMatrixTeller];
            end; //FieldName
          end;
        end;
      end; //recordteller
      result := true;
      VirtualTable[FMatrixTeller].CreateDataSet;
      FDataSource[FMatrixTeller].DataSet := VirtualTable[FMatrixTeller];
      VirtualTable[FMatrixTeller].Active := true;
    except
      result := false;
    end;
  finally
    Velden.Free;
  end;
end;

function TMatrixString.CreateMatrixStringFields(VirtTable : TBufdataset; const MatrixNr : byte = 1) : boolean;
begin
  VirtTable.Filter := 'matrixnummer = ' + inttostr(Matrixnr);
  VirtTable.Filtered := true;
  FMatrixteller := MatrixNr - 1;
  if VirtualTable[FMatrixTeller].Active then
     VirtualTable[FMatrixTeller].Active := false;
  try
    //eerste veld is voor master detail relatie als er meerder scripts zijn
    with VirtualTable[FMatrixTeller] do
    begin
       with TIntegerField.Create(nil) do
       begin
         Name := 'MSDT_snr';
         FieldKind := fkData;
         FieldName := 'MSDT_snr';
         DataSet := VirtualTable[FMatrixTeller];
       end;
    end;

    while not VirtTable.Eof do
    begin
       with VirtualTable[FMatrixTeller] do
       begin
         if VirtTable.FieldByName('datatype').AsString = 'S' then
         begin
           with TStringField.Create(nil) do
           begin
             Name := VirtTable.FieldByName('veldnaam').AsString;
             FieldKind := fkData;
             FieldName := VirtTable.FieldByName('veldnaam').AsString;
             Size := VirtTable.FieldByName('veldgrootte').AsInteger;
             DataSet := VirtualTable[FMatrixTeller];
           end; //FieldName
         end
         else if VirtTable.FieldByName('datatype').AsString = 'N' then
         begin
           with TIntegerField.Create(nil) do
           begin
             Name := VirtTable.FieldByName('veldnaam').AsString;
             FieldKind := fkData;
             FieldName := VirtTable.FieldByName('veldnaam').AsString;
             DataSet := VirtualTable[FMatrixTeller];
           end; //FieldName
         end
         else if (VirtTable.FieldByName('datatype').AsString = 'D') or
                 (VirtTable.FieldByName('datatype').AsString = 'T') then
         begin
           with TDateTimeField.Create(nil) do
           begin
             Name := VirtTable.FieldByName('veldnaam').AsString;
             FieldKind := fkData;
             FieldName := VirtTable.FieldByName('veldnaam').AsString;
             DataSet := VirtualTable[FMatrixTeller];
           end; //FieldName
         end
         else if VirtTable.FieldByName('datatype').AsString = 'F' then
         begin
           with TFloatField.Create(nil) do
           begin
             Name := VirtTable.FieldByName('veldnaam').AsString;
             FieldKind := fkData;
             FieldName := VirtTable.FieldByName('veldnaam').AsString;
             DataSet := VirtualTable[FMatrixTeller];
           end; //FieldName
         end
         else if VirtTable.FieldByName('datatype').AsString = 'M' then
         begin
           with TMemoField.Create(nil) do
           begin
             Name := VirtTable.FieldByName('veldnaam').AsString;
             FieldKind := fkData;
             FieldName := VirtTable.FieldByName('veldnaam').AsString;
             DataSet := VirtualTable[FMatrixTeller];
           end; //FieldName
         end
         else if VirtTable.FieldByName('datatype').AsString = 'B' then
         begin
           with TBooleanField.Create(nil) do
           begin
             Name := VirtTable.FieldByName('veldnaam').AsString;
             FieldKind := fkData;
             FieldName := VirtTable.FieldByName('veldnaam').AsString;
             DataSet := VirtualTable[FMatrixTeller];
           end; //FieldName
         end;
       end;
       VirtTable.Next;
    end;
    result := true;
    VirtualTable[FMatrixTeller].CreateDataSet;
    FDataSource[FMatrixTeller].DataSet := VirtualTable[FMatrixTeller];
    VirtualTable[FMatrixTeller].Active := true;
  except
    result := false;
  end;
end;

function TMatrixString.Save(Bestand: string; const Matrixnr : byte = 1): boolean;
begin
  result := true;
  try
    FMatrixteller := MatrixNr - 1;
    VirtualTable[FMatrixTeller].SaveToFile(bestand);
  except
    result := false;
  end;
end;

function TMatrixString.Load(Bestand: string; const Matrixnr : byte = 1): boolean;
begin
  FMatrixteller := MatrixNr - 1;
  VirtualTable[FMatrixTeller].LoadFromFile(bestand);
  VirtualTable[FMatrixTeller].Active := true;
  result := true;
end;

function TMatrixString.Locate(const zoekstring : string;
                              arValues : array of variant;
                              const MatrixNr: byte = 1) : boolean;
begin
  FMatrixteller := MatrixNr - 1;
  result := VirtualTable[FMatrixTeller].Locate(zoekstring,vararrayof(arValues),[]);
end;

function TMatrixString.Active(const ParIntNummer: word = 1): boolean;
begin
  FMatrixteller := ParIntNummer - 1;
  result := VirtualTable[FMatrixTeller].active;
end;

procedure TMatrixString.CopyCBSDataset(CopyDsSet: TDataSet; const ParIntNummer: word);
begin
  FMatrixTeller := ParIntNummer - 1;
//  CreateCopyFields(CopyDsSet, FMatrixTeller);
  CopyDsSet.First;
  while not CopyDsSet.Eof do
  begin
    VirtualTable[FMatrixTeller].Append;
    VirtualTable[FMatrixTeller].FieldByName('MSDT_snr').AsInteger := CopyDsSet.FieldByName('cbs_snr').AsInteger;
    VirtualTable[FMatrixTeller].FieldByName('cbs_nummer').AsString := CopyDsSet.FieldByName('cbs_nummer').AsString;
    VirtualTable[FMatrixTeller].FieldByName('cbs_omschrijving').AsString := CopyDsSet.FieldByName('cbs_omschrijving').AsString;
    VirtualTable[FMatrixTeller].FieldByName('cbs_gewicht').AsFloat := CopyDsSet.FieldByName('cbs_gewicht').AsFloat;
    VirtualTable[FMatrixTeller].FieldByName('cbs_aantal').AsInteger := CopyDsSet.FieldByName('cbs_aantal').AsInteger;
    VirtualTable[FMatrixTeller].FieldByName('cbs_bedrag').AsFloat := CopyDsSet.FieldByName('cbs_bedrag').AsFloat;
    VirtualTable[FMatrixTeller].FieldByName('cbs_embgewicht').AsFloat := CopyDsSet.FieldByName('cbs_embgewicht').AsInteger;
    VirtualTable[FMatrixTeller].Post;
    CopyDsSet.Next;
  end;
end;

procedure TMatrixString.CopyDataset(CopyDsSet: TDataSet; const ParIntNummer: word);
var teller : smallint;
begin
  FMatrixTeller := ParIntNummer - 1;
//  CreateCopyFields(CopyDsSet, FMatrixTeller);
  CopyDsSet.First;
  while not CopyDsSet.Eof do
  begin
    VirtualTable[FMatrixTeller].Append;
    for teller := 0 to VirtualTable[FMatrixTeller].FieldCount - 1 do
    begin
      VirtualTable[FMatrixTeller].Fields[teller].Value :=
        CopyDsSet.Fields[teller].Value;
    end;
    VirtualTable[FMatrixTeller].Post;
    CopyDsSet.Next;
  end;
end;

end.
