unit dConnections;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, IBConnection, sqldblib, sqldb, db, FileUtil, clCreateDatabase;

type

  { TDMConnections }

  TDMConnections = class(TDataModule)
    IBConnection1: TIBConnection;
    SQLDBLibraryLoader1: TSQLDBLibraryLoader;
    SQLTransaction1: TSQLTransaction;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    function DBConnection : TIBConnection;
  end;

var
  DMConnections: TDMConnections;

implementation

{$R *.lfm}

{ TDMConnections }

procedure TDMConnections.DataModuleCreate(Sender: TObject);
var programdata : string;
    DBCreate    : TCreateDatabase;
begin
  DBCreate    := TCreateDatabase.create;
  try
  //zoeken naar bestand
  SQLDBLibraryLoader1.enabled := true;
  programdata := GetEnvironmentVariable('ALLUSERSPROFILE')  + '\factory';
  if not directoryexists(programdata) then
    mkdir(programdata);
  IBConnection1.DatabaseName := programdata + '\factory.FDB';

  if not FileExists(IBConnection1.DatabaseName) then
    DBCreate.start;
  finally
    DBCreate.Free;
  end;
  IBConnection1.Open;
end;

procedure TDMConnections.DataModuleDestroy(Sender: TObject);
begin
  IBConnection1.close;
end;

function TDMConnections.DBConnection: TIBConnection;
begin
  result := IBConnection1;
end;

end.

