unit clInvoiceslist;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, variants, dialogs, clBase, dInvoices, clLazGlobals,
  clLazFunctions, clMyTypes;

type

 { TInvoicelist }

 TInvoicelist = class(TBase)
 private
   fRGExport         : smallint;
   function GetModule: TDMInvoices;
  protected
  public
    constructor Create; override;
    destructor  Destroy; override;

    function Init(Ds1 : TDatasource) : boolean;

    procedure StartInvoiceEdit(const aNew : boolean);

    property Datamodule : TDMInvoices read GetModule;
    property RGExport   : smallint read fRGExport write fRGExport;
end;

implementation

{ TInvoicelist }

uses dConnections;

constructor TInvoicelist.Create;
begin
  inherited Create;
  CreateDMModule(TDMInvoices);
end;

destructor TInvoicelist.Destroy;
begin
  datamodule.free;
  inherited Destroy;
end;

function TInvoicelist.Init(Ds1: TDatasource): boolean;
begin
  datamodule.SQLinvoices.database    := DMConnections.DBConnection;
  datamodule.Trinvoices.DataBase     := DMConnections.DBConnection;
  datamodule.SQLinvoices.Transaction := datamodule.Trinvoices;
  fCurrentdataset  := datamodule.SQLinvoices;
//  BasisQuery       := datamodule.SQLinvoices.SQL.text;
//  CurrentTablename := datamodule.SQLinvoices.name;
  if fCurrentdataset <> nil then
  begin
    Ds1.dataset            := fCurrentdataset;
    fCurrentdataset.Active := true;
    fcurrentdataset.FieldByName('ID').Required := false;
    result := true;
  end else
    result := false;
end;

procedure TInvoicelist.StartInvoiceEdit(const aNew: boolean);
begin
  try
    fCurrentdataset.disablecontrols;
    if aNew then
      uGlobal.PutInt('INVOICE_ID',-1)
    else
      uGlobal.PutInt('INVOICE_ID',fCurrentdataset.fieldbyname('id').AsInteger);
    NextForm('FrmInvoiceEdit', nxcenter);
    fcurrentdataset.refresh;
    fcurrentdataset.Locate('id',vararrayof([uGlobal.GetVarInt('INVOICE_ID')]),[])
  finally
    fCurrentdataset.enablecontrols;
    uGlobal.Remove('INVOICE_ID');
  end;
end;

function TInvoicelist.GetModule: TDMInvoices;
begin
  result := TDMInvoices(inherited datamodule)
end;


end.

