unit clmain;

interface

uses sysutils, classes, variants, stdctrls, ComCtrls, clBase, DMain,
     controls, clLazFunctions, clLazGlobals, clMyTypes;

type


{ TMain }

 TMain = class(TBase)
  private
    fHoofdschermTekst : string;
    fCurrentFrame     : TBasisFrames;
    fTbFormbody       : TTabSheet;
//    fImageList        : TImageList;

    function GetDatamodule: TDMMain;
    procedure StartAction(const aCaption, aFrame: string);
  public
    constructor Create; override;
    destructor  Destroy; override;

    procedure init(aTbFormbody: TTabSheet);
    procedure MenuClick(const aDisplaytext: string; const aIndex : integer);

    property Datamodule : TDMMain read GetDatamodule;
    property HoofdschermTekst : string read fHoofdschermTekst;
end;

implementation

{ TMain }

uses dialogs;

constructor TMain.Create;
begin
  inherited;
  CreateDMModule(TDMMain);
end;

destructor TMain.Destroy;
begin
  datamodule.free;
  inherited Destroy;
end;

procedure TMain.init(aTbFormbody: TTabSheet);
begin
  fTbFormbody := aTbFormbody;
  datamodule.GetDefaults;
end;

procedure TMain.MenuClick(const aDisplaytext: string; const aIndex : integer);
var Formname : string;
begin
  fHoofdschermTekst := '';
  case aIndex of
    1 : Formname := 'FrmInvoicelist';
    2 : Formname := 'FrmCustomers';
    3 : Formname := 'FrmCountries';
    4 : Formname := 'FrmVAT';
    5 : Formname := 'FrmDefaults';
  end;
  StartAction(aDisplaytext, Formname)
end;

procedure TMain.StartAction(const aCaption, aFrame : string);
begin
  if fCurrentFrame.Frame <> nil then
    fCurrentFrame.Frame.Close;
  fCurrentFrame.Framename := aCaption;
  fCurrentFrame.Frame     := NextFrame(aFrame,fTbFormbody);
  fTbFormbody.Caption      := fCurrentFrame.Framename;
end;

function TMain.GetDatamodule: TDMMain;
begin
  result := TDMMain(inherited Datamodule)
end;

end.
