unit clDefaults;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, variants, dialogs, clBase, dmain, clLazGlobals;

type

 { TDefaults }

 TDefaults = class(TBase)
 private
   fdesigner       : boolean;
   finvoicenumber  : integer;
   freportname     : string;

   function GetModule: TDMMain;
  protected
  public
    constructor Create; override;
    destructor  Destroy; override;

    function Init(Ds1 : TDatasource) : boolean;

    procedure save;

    property Datamodule : TDMMain read GetModule;

    property Reportname    : string read fReportname write fReportname;
    property Invoicenumber : integer read finvoicenumber write finvoicenumber;
    property Designer      : boolean read fdesigner write fdesigner;
end;

implementation

{ TDefaults }

uses dConnections;

constructor TDefaults.Create;
begin
  inherited Create;
  CreateDMModule(TDMMain);
end;

destructor TDefaults.Destroy;
begin
  datamodule.GetDefaults;
  datamodule.free;
  inherited Destroy;
end;

function TDefaults.Init(Ds1: TDatasource): boolean;
begin
  datamodule.SQLDefaults.database    := DMConnections.DBConnection;
  datamodule.TrDefaults.DataBase     := DMConnections.DBConnection;
  datamodule.SQLDefaults.Transaction := datamodule.TrDefaults;
  fCurrentdataset  := datamodule.SQLDefaults;
//  BasisQuery       := datamodule.SQLDefaults.SQL.text;
  if fCurrentdataset <> nil then
  begin
    Ds1.dataset            := fCurrentdataset;
    fCurrentdataset.Active := true;
    fcurrentdataset.FieldByName('ID').Required := false;
    if fcurrentdataset.Locate('deflable',vararrayof(['REPORT']),[]) then
      freportname := fcurrentdataset.fieldbyname('defvalue').AsString;
    if fcurrentdataset.Locate('deflable',vararrayof(['INVOICENO']),[]) then
     finvoicenumber := fcurrentdataset.fieldbyname('defvalue').AsInteger;
    if fcurrentdataset.Locate('deflable',vararrayof(['DESIGNER']),[]) then
     fdesigner := StrToBool(fcurrentdataset.fieldbyname('defvalue').AsString);
    result := true;
  end else
    result := false;
end;

procedure TDefaults.save;

procedure LocalPost(const aLabel : string; aWaarde : variant);
begin
  if fcurrentdataset.Locate('deflable',vararrayof([aLabel]),[]) then
    fCurrentdataset.Edit
  else
    fCurrentdataset.Append;
  fCurrentdataset.FieldByName('defvalue').Value := aWaarde;
  fCurrentdataset.post;
end;

begin
  LocalPost('REPORT',freportname);
  LocalPost('INVOICENO',finvoicenumber);
  LocalPost('DESIGNER',fdesigner);
end;

function TDefaults.GetModule: TDMMain;
begin
  result := TDMMain(inherited datamodule)
end;

end.

